---
title: POST /work-requests
slug: content-marketing-platform/api/post-work-requests
docTags: 
createdAt: 2026-10-01T18:51:26.265Z
---

{
  "id": "xHPLipy4dx45hNf-Th9OI",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://api.cmp.optimizely.com/v3/work-requests",
    "servers": [
      {
        "url": "https://api.cmp.optimizely.com/v3/work-requests",
        "description": "v3 version of Optimizely CMP Open API"
      }
    ],
    "name": "POST /work-requests",
    "description": "<p>Experimental Create a work request.</p>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "example": "{\"template_id\":\"5c89aebe611eca11302420af\",\"assignees\":[\"74ba987cc9251689abc123\"],\"form_fields\":[{\"identifier\":\"title\",\"type\":\"text\",\"values\":[\"Some title\"]},{\"identifier\":\"brief\",\"type\":\"brief\",\"values\":[{\"type\":\"attachment_brief\",\"value\":{\"key\":\"10d5c89aebe611eca11302420ac80002\",\"name\":\"Attachment\"}}]},{\"identifier\":\"630c486a90546926f034ea28\",\"type\":\"richtext\",\"values\":[\"<b>rich</b> text\"]},{\"identifier\":\"630c479690546926f034ea13\",\"type\":\"label\",\"values\":[\"630c479690546926f034ea15\"]},{\"identifier\":\"630c47be90546926f034ea17\",\"type\":\"dropdown\",\"values\":[\"630c47be90546926f034ea18\"]},{\"identifier\":\"630c482b90546926f034ea22\",\"type\":\"simple_number\",\"values\":[1234.345678]},{\"identifier\":\"630c484b90546926f034ea23\",\"type\":\"percentage_number\",\"values\":[23]},{\"identifier\":\"630c481b90546926f034ea21\",\"type\":\"currency_number\",\"values\":[123.56]},{\"identifier\":\"630c485e90546926f034ea24\",\"type\":\"checkbox\",\"values\":[\"630c485e90546926f034ea25\"]},{\"identifier\":\"630c47d290546926f034ea1b\",\"type\":\"radio_button\",\"values\":[\"630c47d290546926f034ea1c\"]},{\"identifier\":\"creative_assets\",\"type\":\"file\",\"values\":[{\"key\":\"creative-asset-key-1\",\"name\":\"Creative Asset 1\"},{\"key\":\"creative-asset-key-2\",\"name\":\"Creative Asset 2\"}]},{\"identifier\":\"due_date\",\"type\":\"date\",\"values\":[\"2022-02-20T12:02:03.000000Z\"]},{\"identifier\":\"media_links\",\"type\":\"text_area\",\"values\":[\"some text\\nmore text\"]}]}",
          "description": "Payload to create a work request",
          "customType": "WorkRequestCreateRequest",
          "schema": [
            {
              "name": "template_id",
              "kind": "required",
              "type": "string",
              "description": "The template on which the work request should be created",
              "example": "1265ca474ba987cc925164aa7"
            },
            {
              "name": "assignees",
              "kind": "optional",
              "type": "array",
              "description": "List of assigned users to the work request",
              "example": "",
              "itemType": "string",
              "customType": "string[]",
              "itemExample": "74ba987cc9251689abc123",
              "itemDefault": ""
            },
            {
              "name": "form_fields",
              "kind": "required",
              "type": "object",
              "description": "<p>Form fields from the work request template to populate in the work request. <strong>NOTE</strong> You must provide values for all the required form fields.</p>",
              "modelRef": "#/components/schemas/TextTypeFormFieldRequest",
              "customType": "TextTypeFormFieldRequest[]",
              "schema": [],
              "complexType": "allOf",
              "complexItems": [
                {
                  "name": "BaseFormFieldRequest",
                  "description": "",
                  "modelRef": "#/components/schemas/BaseFormFieldRequest",
                  "schema": [
                    {
                      "name": "identifier",
                      "kind": "required",
                      "type": "string",
                      "description": "Identifier of the form field collected from the template form field",
                      "example": "brief"
                    },
                    {
                      "name": "type",
                      "kind": "required",
                      "type": "string",
                      "description": "Type of the form field",
                      "example": "brief"
                    },
                    {
                      "name": "values",
                      "kind": "required",
                      "type": "array",
                      "description": "Values for the form field to populate in the work request",
                      "example": "",
                      "itemType": "object",
                      "customType": "object[]",
                      "itemExample": "",
                      "itemDefault": ""
                    }
                  ]
                },
                {
                  "name": "object",
                  "description": "",
                  "schema": [
                    {
                      "name": "values",
                      "kind": "optional",
                      "type": "array",
                      "description": "",
                      "example": "",
                      "itemType": "string",
                      "customType": "string[]",
                      "itemExample": "Sample text",
                      "itemDefault": ""
                    }
                  ]
                }
              ]
            }
          ],
          "modelRef": "#/components/schemas/WorkRequestCreateRequest",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "OAuth2",
          "name": "OAuth2",
          "kind": "optional",
          "type": "oauth2",
          "oauth2Flows": {
            "clientCredentials": {
              "tokenUrl": "https://accounts.cmp.optimizely.com/o/oauth2/v1/token",
              "scopes": {}
            },
            "authorizationCode": {
              "authorizationUrl": "https://accounts.cmp.optimizely.com/o/oauth2/v1/auth",
              "tokenUrl": "https://accounts.cmp.optimizely.com/o/oauth2/v1/token",
              "scopes": {
                "openid": "Grants the ability to receive a unique identifier for the user.",
                "profile": "Grants access to user profile information.",
                "offline_access": "Grants the ability to refresh access_token using the refresh token even when user is not present (not logged in)."
              }
            }
          },
          "requiredScopes": [
            "openid",
            "profile",
            "offline_access"
          ]
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "201",
        "description": "Created work request",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "WorkRequestResponse",
            "schema": [
              {
                "name": "id",
                "kind": "required",
                "type": "string",
                "description": "Unique identifier of the work request",
                "example": "5fe4925ef8a9378056bf4e37"
              },
              {
                "name": "template",
                "kind": "required",
                "type": "object",
                "description": "<p>The template, based on the work request that was created</p>",
                "example": "",
                "schema": [
                  {
                    "name": "id",
                    "kind": "required",
                    "type": "string",
                    "description": "Unique identifier of the template",
                    "example": "1265ca474ba987cc925164aa7"
                  },
                  {
                    "name": "title",
                    "kind": "required",
                    "type": "string",
                    "description": "Title of the template",
                    "example": "Sample template title"
                  },
                  {
                    "name": "links",
                    "kind": "required",
                    "type": "object",
                    "description": "Meta links",
                    "example": "",
                    "schema": [
                      {
                        "name": "self",
                        "kind": "required",
                        "type": "string",
                        "description": "URL of the template",
                        "example": "https://api.cmp.optimizely.com/v3/templates/9119a313057e401189407116fcd3aa24"
                      }
                    ]
                  }
                ]
              },
              {
                "name": "reference_id",
                "kind": "required",
                "type": "string",
                "description": "Reference identifier of the work request",
                "example": "WRQ-23"
              },
              {
                "name": "assignees",
                "kind": "required",
                "type": "array",
                "description": "List of assigned users to the work request",
                "example": "",
                "itemType": "object",
                "customType": "object[]",
                "schema": [
                  {
                    "name": "id",
                    "kind": "required",
                    "type": "string",
                    "description": "Unique identifier of the assignee",
                    "example": "6asdcnfnfdsfdsfd54sgfd54sf"
                  },
                  {
                    "name": "type",
                    "kind": "required",
                    "type": "string<user | team>",
                    "description": "Type of the assignee",
                    "example": "user",
                    "enum": [
                      "user",
                      "team"
                    ]
                  },
                  {
                    "name": "full_name",
                    "kind": "required",
                    "type": "string",
                    "description": "Full name of the assignee",
                    "example": "John Doe"
                  },
                  {
                    "name": "image_url",
                    "kind": "required",
                    "type": "string",
                    "nullable": true,
                    "description": "<p>URL of the profile picture of the assignee. <code>null</code> if the assignee has not provided an image</p>",
                    "example": "https://images.cmp.optimizely.com/6a485f72ba424f9397c71ddf0cfb8f59"
                  },
                  {
                    "name": "links",
                    "kind": "required",
                    "type": "object",
                    "description": "Meta links",
                    "example": "",
                    "schema": [
                      {
                        "name": "self",
                        "kind": "required",
                        "type": "string",
                        "description": "URL of the assigned user",
                        "example": "https://api.cmp.optimizely.com/v3/users/6asdcnfnfdsfdsfd54sgfd54sf"
                      }
                    ]
                  }
                ]
              },
              {
                "name": "status",
                "kind": "required",
                "type": "string<Accepted | Declined | Submitted | Completed>",
                "description": "Current status of the work request",
                "example": "Accepted",
                "enum": [
                  "Accepted",
                  "Declined",
                  "Submitted",
                  "Completed"
                ]
              },
              {
                "name": "priority",
                "kind": "required",
                "type": "string<Low | Medium | High>",
                "description": "Priority of the work request",
                "example": "Medium",
                "enum": [
                  "Low",
                  "Medium",
                  "High"
                ]
              },
              {
                "name": "created_by",
                "kind": "required",
                "type": "object",
                "description": "Creator of the work request",
                "example": "",
                "schema": [
                  {
                    "name": "id",
                    "kind": "required",
                    "type": "string",
                    "description": "Unique identifier of the creator of the work request",
                    "example": "6asdcnfnfdsfdsfd54sgfd54sf"
                  },
                  {
                    "name": "links",
                    "kind": "required",
                    "type": "object",
                    "description": "Meta links",
                    "example": "",
                    "schema": [
                      {
                        "name": "self",
                        "kind": "required",
                        "type": "string",
                        "description": "URL of the creator",
                        "example": "https://api.cmp.optimizely.com/v3/users/6asdcnfnfdsfdsfd54sgfd54sf"
                      }
                    ]
                  }
                ]
              },
              {
                "name": "created_at",
                "kind": "required",
                "type": "string<date-time>",
                "description": "<p>Date and time on which the work request was created, in ISO 8601 UTC format (2022-04-30T06:00</p><div></div>.000Z)<p></p>",
                "example": "2022-04-30T06:00:00.000Z",
                "format": "date-time"
              },
              {
                "name": "modified_at",
                "kind": "required",
                "type": "string<date-time>",
                "description": "<p>Date and time on which the work request was last modified, in ISO 8601 UTC format (2022-04-30T08:00</p><div></div>.000Z)<p></p>",
                "example": "2022-04-30T08:00:00.000Z",
                "format": "date-time"
              },
              {
                "name": "form_fields",
                "kind": "required",
                "type": "object",
                "description": "Populated form fields following the template",
                "modelRef": "#/components/schemas/TextTypeFormFieldResponse",
                "customType": "TextTypeFormFieldResponse[]",
                "schema": [],
                "complexType": "allOf",
                "complexItems": [
                  {
                    "name": "BaseFormFieldResponse",
                    "description": "",
                    "modelRef": "#/components/schemas/BaseFormFieldResponse",
                    "schema": [
                      {
                        "name": "identifier",
                        "kind": "required",
                        "type": "string",
                        "description": "Identifier of the form field collected from the template form field",
                        "example": "brief"
                      },
                      {
                        "name": "type",
                        "kind": "required",
                        "type": "string",
                        "description": "Type of the form field",
                        "example": "brief"
                      },
                      {
                        "name": "values",
                        "kind": "required",
                        "type": "array",
                        "description": "Values of the form field",
                        "example": "",
                        "itemType": "object",
                        "customType": "object[]",
                        "itemExample": "",
                        "itemDefault": ""
                      },
                      {
                        "name": "is_protected",
                        "kind": "optional",
                        "type": "boolean",
                        "description": "<p>True when this form field is read-only and only organization admins can modify it. Absent or false for editable fields.</p>",
                        "example": false
                      }
                    ]
                  },
                  {
                    "name": "object",
                    "description": "",
                    "schema": [
                      {
                        "name": "values",
                        "kind": "optional",
                        "type": "array",
                        "description": "",
                        "example": "",
                        "itemType": "string",
                        "customType": "string[]",
                        "itemExample": "Sample text",
                        "itemDefault": ""
                      }
                    ]
                  }
                ]
              },
              {
                "name": "links",
                "kind": "required",
                "type": "object",
                "description": "Meta links",
                "example": "",
                "schema": [
                  {
                    "name": "self",
                    "kind": "required",
                    "type": "string",
                    "description": "URL of the work request",
                    "example": "https://api.cmp.optimizely.com/v3/work-requests/5fe4925ef8a9378056bf4e37"
                  },
                  {
                    "name": "comments",
                    "kind": "required",
                    "type": "string",
                    "description": "URL to create or get work request comments",
                    "example": "https://api.cmp.optimizely.com/v3/work-requests/5fe4925ef8a9378056bf4e37/comments"
                  },
                  {
                    "name": "attachments",
                    "kind": "required",
                    "type": "string",
                    "description": "URL to add attachments to work request",
                    "example": "https://api.cmp.optimizely.com/v3/work-requests/5fe4925ef8a9378056bf4e37/attachments"
                  },
                  {
                    "name": "campaigns",
                    "kind": "required",
                    "type": "string",
                    "description": "URL to create a campaign from the work request",
                    "example": "https://api.cmp.optimizely.com/v3/work-requests/5fe4925ef8a9378056bf4e37/campaigns"
                  },
                  {
                    "name": "tasks",
                    "kind": "required",
                    "type": "string",
                    "description": "URL to create a task from the work request",
                    "example": "https://api.cmp.optimizely.com/v3/work-requests/5fe4925ef8a9378056bf4e37/tasks"
                  },
                  {
                    "name": "creative_assets",
                    "kind": "required",
                    "type": "string",
                    "description": "URL to add creative assets to the work request",
                    "example": "https://api.cmp.optimizely.com/v3/work-requests/5fe4925ef8a9378056bf4e37/creative-assets"
                  },
                  {
                    "name": "related_resources",
                    "kind": "required",
                    "type": "string",
                    "description": "URL to get related resources",
                    "example": "https://api.cmp.optimizely.com/v3/work-requests/5fe4925ef8a9378056bf4e37/related-resources"
                  }
                ]
              }
            ],
            "modelRef": "#/components/schemas/WorkRequestResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Authorization error",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "example": "{\"message\":\"Unauthorized\"}",
            "description": "Error payload",
            "customType": "Error",
            "schema": [
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "Message describing the error",
                "example": "Not found"
              },
              {
                "name": "errors",
                "kind": "optional",
                "type": "map",
                "description": "Additional information",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/Error",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "403",
        "description": "Permission error",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "example": "{\"message\":\"You do not have the permission to perform this operation\"}",
            "description": "Error payload",
            "customType": "Error",
            "schema": [
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "Message describing the error",
                "example": "Not found"
              },
              {
                "name": "errors",
                "kind": "optional",
                "type": "map",
                "description": "Additional information",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/Error",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "422",
        "description": "Unprocessable entity error",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "example": "{\"message\":\"Resource cannot be processed\"}",
            "description": "Error payload",
            "customType": "Error",
            "schema": [
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "Message describing the error",
                "example": "Not found"
              },
              {
                "name": "errors",
                "kind": "optional",
                "type": "map",
                "description": "Additional information",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/Error",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "mgw81U0V90t8wHXiPOVZF",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://api.cmp.optimizely.com/v3/work-requests \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --data '{\n     \"template_id\": \"1265ca474ba987cc925164aa7\",\n     \"form_fields\": {\n     \"identifier\": \"brief\",\n     \"type\": \"brief\",\n     \"values\": []\n     }\n     }'"
        },
        {
          "id": "pnN68PZhdFIDANr91YsAP",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar raw = JSON.stringify({\n   \"template_id\": \"1265ca474ba987cc925164aa7\",\n   \"form_fields\": {\n      \"identifier\": \"brief\",\n      \"type\": \"brief\",\n      \"values\": []\n   }\n});\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.cmp.optimizely.com/v3/work-requests\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "zcNNG3YHWPOjzfL7-0Qzk",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.cmp.optimizely.com/v3/work-requests\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest.body = JSON.dump({\n   \"template_id\": \"1265ca474ba987cc925164aa7\",\n   \"form_fields\": {\n      \"identifier\": \"brief\",\n      \"type\": \"brief\",\n      \"values\": []\n   }\n})\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "HU79i3ImtvvMRydOtKI05",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.cmp.optimizely.com/v3/work-requests\"\n\npayload = json.dumps({\n   \"template_id\": \"1265ca474ba987cc925164aa7\",\n   \"form_fields\": {\n      \"identifier\": \"brief\",\n      \"type\": \"brief\",\n      \"values\": []\n   }\n})\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "mgw81U0V90t8wHXiPOVZF"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-201",
          "language": "201",
          "code": "// Created work request\n{\n  \"id\": \"5fe4925ef8a9378056bf4e37\",\n  \"template\": {\n    \"id\": \"1265ca474ba987cc925164aa7\",\n    \"title\": \"Sample template title\",\n    \"links\": {\n      \"self\": \"https://api.cmp.optimizely.com/v3/templates/9119a313057e401189407116fcd3aa24\"\n    }\n  },\n  \"reference_id\": \"WRQ-23\",\n  \"assignees\": [\n    {\n      \"id\": \"6asdcnfnfdsfdsfd54sgfd54sf\",\n      \"type\": \"user\",\n      \"full_name\": \"John Doe\",\n      \"image_url\": \"https://images.cmp.optimizely.com/6a485f72ba424f9397c71ddf0cfb8f59\",\n      \"links\": {\n        \"self\": \"https://api.cmp.optimizely.com/v3/users/6asdcnfnfdsfdsfd54sgfd54sf\"\n      }\n    }\n  ],\n  \"status\": \"Accepted\",\n  \"priority\": \"Medium\",\n  \"created_by\": {\n    \"id\": \"6asdcnfnfdsfdsfd54sgfd54sf\",\n    \"links\": {\n      \"self\": \"https://api.cmp.optimizely.com/v3/users/6asdcnfnfdsfdsfd54sgfd54sf\"\n    }\n  },\n  \"created_at\": \"2022-04-30T06:00:00.000Z\",\n  \"modified_at\": \"2022-04-30T08:00:00.000Z\",\n  \"form_fields\": {},\n  \"links\": {\n    \"self\": \"https://api.cmp.optimizely.com/v3/work-requests/5fe4925ef8a9378056bf4e37\",\n    \"comments\": \"https://api.cmp.optimizely.com/v3/work-requests/5fe4925ef8a9378056bf4e37/comments\",\n    \"attachments\": \"https://api.cmp.optimizely.com/v3/work-requests/5fe4925ef8a9378056bf4e37/attachments\",\n    \"campaigns\": \"https://api.cmp.optimizely.com/v3/work-requests/5fe4925ef8a9378056bf4e37/campaigns\",\n    \"tasks\": \"https://api.cmp.optimizely.com/v3/work-requests/5fe4925ef8a9378056bf4e37/tasks\",\n    \"creative_assets\": \"https://api.cmp.optimizely.com/v3/work-requests/5fe4925ef8a9378056bf4e37/creative-assets\",\n    \"related_resources\": \"https://api.cmp.optimizely.com/v3/work-requests/5fe4925ef8a9378056bf4e37/related-resources\"\n  }\n}"
        },
        {
          "id": "response-1-401",
          "language": "401",
          "code": "// Authorization error\n{\n  \"message\": \"Not found\",\n  \"errors\": \"\"\n}"
        },
        {
          "id": "response-2-403",
          "language": "403",
          "code": "// Permission error\n{\n  \"message\": \"Not found\",\n  \"errors\": \"\"\n}"
        },
        {
          "id": "response-3-422",
          "language": "422",
          "code": "// Unprocessable entity error\n{\n  \"message\": \"Not found\",\n  \"errors\": \"\"\n}"
        }
      ],
      "selectedLanguageId": "response-0-201"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}